//thank you Ancientkingg for these shaders, you're the best :D https://twitter.com/ancientkingg

#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 lightMapColor;
in vec4 overlayColor;
in vec2 texCoord0;
in vec4 normal;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    if (color.a < 0.1) discard;
    vec4 vtc = vec4(color.a) * (1 - vertexColor) + vertexColor;
    if (color.a >= (253.0 / 255.0) && color.a <= (254.0 / 255.0)){
        color = color * ColorModulator * vtc;
        fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    }else{
        color *= vertexColor * ColorModulator;
        fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
    }
    
}
